﻿// DialogHex.cpp : implementation file
//

#include "stdafx.h"
#include "Resource.h"
#include "DialogLED.h"
#include "HID.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define HID_PACKET_SIZE 64
#define USB_TIME_OUT    100
CHidCmd io;
bool isDeviceOpened = 0;

#include <Mmdeviceapi.h>
#include <Endpointvolume.h>
#include <Audioclient.h>
const CLSID CLSID_MMDeviceEnumerator = __uuidof(MMDeviceEnumerator);  
const IID IID_IMMDeviceEnumerator = __uuidof(IMMDeviceEnumerator);
const IID IID_IAudioEndpointVolume = __uuidof(IAudioEndpointVolume);
const IID IID_IAudioMeterInformation = __uuidof(IAudioMeterInformation);
CComPtr<IMMDeviceEnumerator> m_pIMMEnumerator;
//IMMDeviceEnumerator *m_pIMMEnumerator;
CComPtr<IMMDevice> pIMMDeivce = NULL;
CComPtr<IAudioEndpointVolume> m_pEPVolume;
CComPtr<IAudioMeterInformation> m_pRenderEndptVol;

/////////////////////////////////////////////////////////////////////////////
// CDialogLed dialog

CDialogLed *g_pMainDlg;

CDialogLed::CDialogLed(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogLed::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogLed)
	//}}AFX_DATA_INIT
}


void CDialogLed::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogLed)

	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBO_G12_LightingMode, m_cbG12LightingMode);
	DDX_Control(pDX, IDC_COMBO_G34_LightingMode, m_cbG34LightingMode);
	DDX_Control(pDX, IDC_COMBO_G5_LightingMode,  m_cbG5LightingMode);
	DDX_Control(pDX, IDC_COMBO_RGB1_LightingMode,  m_cbRGB1LightingMode);
	DDX_Control(pDX, IDC_COMBO_Bar_LightingMode,  m_cbBarLightingMode);
	DDX_Control(pDX, IDC_COMBO_Graphic_LightingMode,  m_cbGraphicLightingMode);
	DDX_Control(pDX, IDC_COMBO_Stripe_LightingMode,  m_cbStripeLightingMode);
}


BEGIN_MESSAGE_MAP(CDialogLed, CDialog)
	//{{AFX_MSG_MAP(CDialogLed)
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_Apply, &CDialogLed::OnBnClickedButtonApply)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G12_SLIDER_R, &CDialogLed::OnNMCustomdrawG12SliderR)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G12_SLIDER_G, &CDialogLed::OnNMCustomdrawG12SliderG)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G12_SLIDER_B, &CDialogLed::OnNMCustomdrawG12SliderB)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G34_SLIDER_R, &CDialogLed::OnNMCustomdrawG34SliderR)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G34_SLIDER_G, &CDialogLed::OnNMCustomdrawG34SliderG)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G34_SLIDER_B, &CDialogLed::OnNMCustomdrawG34SliderB)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G5_SLIDER_R,  &CDialogLed::OnNMCustomdrawG5SliderR)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G5_SLIDER_G,  &CDialogLed::OnNMCustomdrawG5SliderG)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_G5_SLIDER_B,  &CDialogLed::OnNMCustomdrawG5SliderB)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_RGB1_SLIDER_R,  &CDialogLed::OnNMCustomdrawRGB1SliderR)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_RGB1_SLIDER_G,  &CDialogLed::OnNMCustomdrawRGB1SliderG)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_RGB1_SLIDER_B,  &CDialogLed::OnNMCustomdrawRGB1SliderB)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Bar_SLIDER_R,  &CDialogLed::OnNMCustomdrawBarSliderR)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Bar_SLIDER_G,  &CDialogLed::OnNMCustomdrawBarSliderG)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Bar_SLIDER_B,  &CDialogLed::OnNMCustomdrawBarSliderB)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Graphic_SLIDER_R,  &CDialogLed::OnNMCustomdrawGraphicSliderR)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Graphic_SLIDER_G,  &CDialogLed::OnNMCustomdrawGraphicSliderG)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Graphic_SLIDER_B,  &CDialogLed::OnNMCustomdrawGraphicSliderB)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Stripe_SLIDER_R,  &CDialogLed::OnNMCustomdrawStripeSliderR)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Stripe_SLIDER_G,  &CDialogLed::OnNMCustomdrawStripeSliderG)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_Stripe_SLIDER_B,  &CDialogLed::OnNMCustomdrawStripeSliderB)
	ON_EN_CHANGE(IDC_G12_EDIT_R, &CDialogLed::OnEnChangeG12EditR)
	ON_EN_CHANGE(IDC_G12_EDIT_G, &CDialogLed::OnEnChangeG12EditG)
	ON_EN_CHANGE(IDC_G12_EDIT_B, &CDialogLed::OnEnChangeG12EditB)
	ON_EN_CHANGE(IDC_G34_EDIT_R, &CDialogLed::OnEnChangeG34EditR)
	ON_EN_CHANGE(IDC_G34_EDIT_G, &CDialogLed::OnEnChangeG34EditG)
	ON_EN_CHANGE(IDC_G34_EDIT_B, &CDialogLed::OnEnChangeG34EditB)
	ON_EN_CHANGE(IDC_G5_EDIT_R,  &CDialogLed::OnEnChangeG5EditR)
	ON_EN_CHANGE(IDC_G5_EDIT_G,  &CDialogLed::OnEnChangeG5EditG)
	ON_EN_CHANGE(IDC_G5_EDIT_B,  &CDialogLed::OnEnChangeG5EditB)
	ON_EN_CHANGE(IDC_RGB1_EDIT_R,  &CDialogLed::OnEnChangeRGB1EditR)
	ON_EN_CHANGE(IDC_RGB1_EDIT_G,  &CDialogLed::OnEnChangeRGB1EditG)
	ON_EN_CHANGE(IDC_RGB1_EDIT_B,  &CDialogLed::OnEnChangeRGB1EditB)
	ON_EN_CHANGE(IDC_Bar_EDIT_R,  &CDialogLed::OnEnChangeBarEditR)
	ON_EN_CHANGE(IDC_Bar_EDIT_G,  &CDialogLed::OnEnChangeBarEditG)
	ON_EN_CHANGE(IDC_Bar_EDIT_B,  &CDialogLed::OnEnChangeBarEditB)
	ON_EN_CHANGE(IDC_Graphic_EDIT_R,  &CDialogLed::OnEnChangeGraphicEditR)
	ON_EN_CHANGE(IDC_Graphic_EDIT_G,  &CDialogLed::OnEnChangeGraphicEditG)
	ON_EN_CHANGE(IDC_Graphic_EDIT_B,  &CDialogLed::OnEnChangeGraphicEditB)
	ON_EN_CHANGE(IDC_Stripe_EDIT_R,  &CDialogLed::OnEnChangeStripeEditR)
	ON_EN_CHANGE(IDC_Stripe_EDIT_G,  &CDialogLed::OnEnChangeStripeEditG)
	ON_EN_CHANGE(IDC_Stripe_EDIT_B,  &CDialogLed::OnEnChangeStripeEditB)
	ON_BN_CLICKED(IDC_BUTTON_Connect, &CDialogLed::OnBnClickedButtonConnect)
	ON_CBN_SELCHANGE(IDC_COMBO_G12_LightingMode, &CDialogLed::OnCbnSelchangeComboG12Lightingmode)
	ON_CBN_SELCHANGE(IDC_COMBO_G34_LightingMode, &CDialogLed::OnCbnSelchangeComboG34Lightingmode)
	ON_CBN_SELCHANGE(IDC_COMBO_G5_LightingMode, &CDialogLed::OnCbnSelchangeComboG5Lightingmode)
	ON_CBN_SELCHANGE(IDC_COMBO_RGB1_LightingMode, &CDialogLed::OnCbnSelchangeComboRGB1Lightingmode)
	ON_CBN_SELCHANGE(IDC_COMBO_Bar_LightingMode, &CDialogLed::OnCbnSelchangeComboBarLightingmode)
	ON_CBN_SELCHANGE(IDC_COMBO_Graphic_LightingMode, &CDialogLed::OnCbnSelchangeComboGraphicLightingmode)
	ON_CBN_SELCHANGE(IDC_COMBO_Stripe_LightingMode, &CDialogLed::OnCbnSelchangeComboStripeLightingmode)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogLed message handlers

BOOL CDialogLed::OnInitDialog() 
{
	CDialog::OnInitDialog();
	g_pMainDlg = this;
	
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_EDIT_VID, __T("0416"));
	CEdit *m_ctlEditVID = (CEdit*) GetDlgItem(IDC_EDIT_VID);
	m_ctlEditVID->SetLimitText(4);
	SetDlgItemText(IDC_EDIT_PID, __T("5020"));
	CEdit *m_ctlEditPID = (CEdit*) GetDlgItem(IDC_EDIT_PID);
	m_ctlEditPID->SetLimitText(4);

	m_cbG12LightingMode.AddString(__T("Disable"));
	m_cbG12LightingMode.AddString(__T("No Animation"));
	m_cbG12LightingMode.AddString(__T("Breathing"));
	m_cbG12LightingMode.AddString(__T("Flashing"));
	m_cbG12LightingMode.AddString(__T("Double Flashing"));
	m_cbG12LightingMode.AddString(__T("Marquees"));
	m_cbG12LightingMode.AddString(__T("Meteor"));
	m_cbG12LightingMode.AddString(__T("Rainbow"));
	m_cbG12LightingMode.AddString(__T("Lighting"));
	m_cbG12LightingMode.AddString(__T("Chasing Meteor"));
	m_cbG12LightingMode.AddString(__T("Up Down"));
	m_cbG12LightingMode.AddString(__T("Waterfall"));
	m_cbG12LightingMode.AddString(__T("Stack"));
	m_cbG12LightingMode.AddString(__T("Rainbow Waterfall"));
	SetDlgItemText(IDC_COMBO_G12_LightingMode, __T("No Animation"));

	m_cbG34LightingMode.AddString(__T("Disable"));
	m_cbG34LightingMode.AddString(__T("No Animation"));
	m_cbG34LightingMode.AddString(__T("Breathing"));
	m_cbG34LightingMode.AddString(__T("Flashing"));
	m_cbG34LightingMode.AddString(__T("Double Flashing"));
	m_cbG34LightingMode.AddString(__T("Marquees"));
	m_cbG34LightingMode.AddString(__T("Meteor"));
	m_cbG34LightingMode.AddString(__T("Rainbow"));
	m_cbG34LightingMode.AddString(__T("Lighting"));
	m_cbG34LightingMode.AddString(__T("Chasing Meteor"));
	m_cbG34LightingMode.AddString(__T("Up Down"));
	m_cbG34LightingMode.AddString(__T("Waterfall"));
	m_cbG34LightingMode.AddString(__T("Stack"));
	m_cbG34LightingMode.AddString(__T("Rainbow Waterfall"));
	SetDlgItemText(IDC_COMBO_G34_LightingMode, __T("No Animation"));

	m_cbG5LightingMode.AddString(__T("Disable"));
	m_cbG5LightingMode.AddString(__T("No Animation"));
	m_cbG5LightingMode.AddString(__T("Breathing"));
	m_cbG5LightingMode.AddString(__T("Flashing"));
	m_cbG5LightingMode.AddString(__T("Double Flashing"));
	m_cbG5LightingMode.AddString(__T("Marquees"));
	m_cbG5LightingMode.AddString(__T("Meteor"));
	m_cbG5LightingMode.AddString(__T("Rainbow"));
	m_cbG5LightingMode.AddString(__T("Lighting"));
	m_cbG5LightingMode.AddString(__T("Stack"));
	m_cbG5LightingMode.AddString(__T("Rainbow Waterfall"));
	SetDlgItemText(IDC_COMBO_G5_LightingMode, __T("No Animation"));

	m_cbRGB1LightingMode.AddString(__T("Disable"));
	m_cbRGB1LightingMode.AddString(__T("No Animation"));
	m_cbRGB1LightingMode.AddString(__T("Breathing"));
	m_cbRGB1LightingMode.AddString(__T("Flashing"));
	m_cbRGB1LightingMode.AddString(__T("Double Flashing"));
	m_cbRGB1LightingMode.AddString(__T("Marquees"));
	m_cbRGB1LightingMode.AddString(__T("Meteor"));
	m_cbRGB1LightingMode.AddString(__T("Rainbow"));
	m_cbRGB1LightingMode.AddString(__T("Lighting"));
	m_cbRGB1LightingMode.AddString(__T("Stack"));
	m_cbRGB1LightingMode.AddString(__T("Rainbow Waterfall"));
	SetDlgItemText(IDC_COMBO_RGB1_LightingMode, __T("No Animation"));

	m_cbBarLightingMode.AddString(__T("Disable"));
	m_cbBarLightingMode.AddString(__T("No Animation"));
	m_cbBarLightingMode.AddString(__T("Breathing"));
	m_cbBarLightingMode.AddString(__T("Flashing"));
	m_cbBarLightingMode.AddString(__T("Double Flashing"));
	m_cbBarLightingMode.AddString(__T("Marquees"));
	m_cbBarLightingMode.AddString(__T("Meteor"));
	m_cbBarLightingMode.AddString(__T("Rainbow"));
	m_cbBarLightingMode.AddString(__T("Lighting"));
	m_cbBarLightingMode.AddString(__T("POP"));
	m_cbBarLightingMode.AddString(__T("JAZZ"));
	m_cbBarLightingMode.AddString(__T("Play"));
	m_cbBarLightingMode.AddString(__T("Movie"));
	SetDlgItemText(IDC_COMBO_Bar_LightingMode, __T("No Animation"));

	m_cbGraphicLightingMode.AddString(__T("Disable"));
	m_cbGraphicLightingMode.AddString(__T("No Animation"));
	m_cbGraphicLightingMode.AddString(__T("Breathing"));
	m_cbGraphicLightingMode.AddString(__T("Flashing"));
	m_cbGraphicLightingMode.AddString(__T("Double Flashing"));
	m_cbGraphicLightingMode.AddString(__T("Marquees"));
	m_cbGraphicLightingMode.AddString(__T("Meteor"));
	m_cbGraphicLightingMode.AddString(__T("Rainbow"));
	m_cbGraphicLightingMode.AddString(__T("Lighting"));
	m_cbGraphicLightingMode.AddString(__T("POP"));
	m_cbGraphicLightingMode.AddString(__T("JAZZ"));
	m_cbGraphicLightingMode.AddString(__T("Play"));
	m_cbGraphicLightingMode.AddString(__T("Movie"));
	SetDlgItemText(IDC_COMBO_Graphic_LightingMode, __T("No Animation"));

	m_cbStripeLightingMode.AddString(__T("Disable"));
	m_cbStripeLightingMode.AddString(__T("No Animation"));
	m_cbStripeLightingMode.AddString(__T("Breathing"));
	m_cbStripeLightingMode.AddString(__T("Flashing"));
	m_cbStripeLightingMode.AddString(__T("Double Flashing"));
	m_cbStripeLightingMode.AddString(__T("Marquees"));
	m_cbStripeLightingMode.AddString(__T("Meteor"));
	m_cbStripeLightingMode.AddString(__T("Rainbow"));
	m_cbStripeLightingMode.AddString(__T("Lighting"));
	m_cbStripeLightingMode.AddString(__T("POP"));
	m_cbStripeLightingMode.AddString(__T("JAZZ"));
	m_cbStripeLightingMode.AddString(__T("Play"));
	m_cbStripeLightingMode.AddString(__T("Movie"));
	SetDlgItemText(IDC_COMBO_Stripe_LightingMode, __T("No Animation"));

	SetDlgItemText(IDC_G12_EDIT_R, __T("0"));
	CEdit *m_ctlG12EditR = (CEdit*) GetDlgItem(IDC_G12_EDIT_R);
	m_ctlG12EditR->SetLimitText(3);
	SetDlgItemText(IDC_G12_EDIT_G, __T("0"));
	CEdit *m_ctlG12EditG = (CEdit*) GetDlgItem(IDC_G12_EDIT_G);
	m_ctlG12EditG->SetLimitText(3);
	SetDlgItemText(IDC_G12_EDIT_B, __T("0"));
	CEdit *m_ctlG12EditB = (CEdit*) GetDlgItem(IDC_G12_EDIT_B);
	m_ctlG12EditB->SetLimitText(3);
	CheckRadioButton(IDC_G12_RADIO0_High, IDC_G12_RADIO0_Low, IDC_G12_RADIO0_Low);
	CheckRadioButton(IDC_G12_RADIO1_B100, IDC_G12_RADIO1_B20, IDC_G12_RADIO1_B100);

	SetDlgItemText(IDC_G34_EDIT_R, __T("0"));
	CEdit *m_ctlG34EditR = (CEdit*) GetDlgItem(IDC_G34_EDIT_R);
	m_ctlG34EditR->SetLimitText(3);
	SetDlgItemText(IDC_G34_EDIT_G, __T("0"));
	CEdit *m_ctlG34EditG = (CEdit*) GetDlgItem(IDC_G34_EDIT_G);
	m_ctlG34EditG->SetLimitText(3);
	SetDlgItemText(IDC_G34_EDIT_B, __T("0"));
	CEdit *m_ctlG34EditB = (CEdit*) GetDlgItem(IDC_G34_EDIT_B);
	m_ctlG34EditB->SetLimitText(3);
	CheckRadioButton(IDC_G34_RADIO0_High, IDC_G34_RADIO0_Low, IDC_G34_RADIO0_Low);
	CheckRadioButton(IDC_G34_RADIO1_B100, IDC_G34_RADIO1_B20, IDC_G34_RADIO1_B100);

	SetDlgItemText(IDC_G5_EDIT_R, __T("0"));
	CEdit *m_ctlG5EditR = (CEdit*) GetDlgItem(IDC_G5_EDIT_R);
	m_ctlG5EditR->SetLimitText(3);
	SetDlgItemText(IDC_G5_EDIT_G, __T("0"));
	CEdit *m_ctlG5EditG = (CEdit*) GetDlgItem(IDC_G5_EDIT_G);
	m_ctlG5EditG->SetLimitText(3);
	SetDlgItemText(IDC_G5_EDIT_B, __T("0"));
	CEdit *m_ctlG5EditB = (CEdit*) GetDlgItem(IDC_G5_EDIT_B);
	m_ctlG5EditB->SetLimitText(3);
	CheckRadioButton(IDC_G5_RADIO0_High, IDC_G5_RADIO0_Low, IDC_G5_RADIO0_Low);
	CheckRadioButton(IDC_G5_RADIO1_B100, IDC_G5_RADIO1_B20, IDC_G5_RADIO1_B100);

	SetDlgItemText(IDC_RGB1_EDIT_R, __T("0"));
	CEdit *m_ctlRGB1EditR = (CEdit*) GetDlgItem(IDC_RGB1_EDIT_R);
	m_ctlRGB1EditR->SetLimitText(3);
	SetDlgItemText(IDC_RGB1_EDIT_G, __T("0"));
	CEdit *m_ctlRGB1EditG = (CEdit*) GetDlgItem(IDC_RGB1_EDIT_G);
	m_ctlRGB1EditG->SetLimitText(3);
	SetDlgItemText(IDC_RGB1_EDIT_B, __T("0"));
	CEdit *m_ctlRGB1EditB = (CEdit*) GetDlgItem(IDC_RGB1_EDIT_B);
	m_ctlRGB1EditB->SetLimitText(3);
	CheckRadioButton(IDC_RGB1_RADIO0_High, IDC_RGB1_RADIO0_Low, IDC_RGB1_RADIO0_Low);
	CheckRadioButton(IDC_RGB1_RADIO1_B100, IDC_RGB1_RADIO1_B20, IDC_RGB1_RADIO1_B100);

	SetDlgItemText(IDC_Bar_EDIT_R, __T("0"));
	CEdit *m_ctlBarEditR = (CEdit*) GetDlgItem(IDC_Bar_EDIT_R);
	m_ctlBarEditR->SetLimitText(3);
	SetDlgItemText(IDC_Bar_EDIT_G, __T("0"));
	CEdit *m_ctlBarEditG = (CEdit*) GetDlgItem(IDC_Bar_EDIT_G);
	m_ctlBarEditG->SetLimitText(3);
	SetDlgItemText(IDC_Bar_EDIT_B, __T("0"));
	CEdit *m_ctlBarEditB = (CEdit*) GetDlgItem(IDC_Bar_EDIT_B);
	m_ctlBarEditB->SetLimitText(3);
	CheckRadioButton(IDC_Bar_RADIO0_High, IDC_Bar_RADIO0_Low, IDC_Bar_RADIO0_Low);
	CheckRadioButton(IDC_Bar_RADIO1_B100, IDC_Bar_RADIO1_B20, IDC_Bar_RADIO1_B20);

	SetDlgItemText(IDC_Graphic_EDIT_R, __T("0"));
	CEdit *m_ctlGraphicEditR = (CEdit*) GetDlgItem(IDC_Graphic_EDIT_R);
	m_ctlGraphicEditR->SetLimitText(3);
	SetDlgItemText(IDC_Graphic_EDIT_G, __T("0"));
	CEdit *m_ctlGraphicEditG = (CEdit*) GetDlgItem(IDC_Graphic_EDIT_G);
	m_ctlGraphicEditG->SetLimitText(3);
	SetDlgItemText(IDC_Graphic_EDIT_B, __T("0"));
	CEdit *m_ctlGraphicEditB = (CEdit*) GetDlgItem(IDC_Graphic_EDIT_B);
	m_ctlGraphicEditB->SetLimitText(3);
	CheckRadioButton(IDC_Graphic_RADIO0_High, IDC_Graphic_RADIO0_Low, IDC_Graphic_RADIO0_Low);
	CheckRadioButton(IDC_Graphic_RADIO1_B100, IDC_Graphic_RADIO1_B20, IDC_Graphic_RADIO1_B20);

	SetDlgItemText(IDC_Stripe_EDIT_R, __T("0"));
	CEdit *m_ctlStripeEditR = (CEdit*) GetDlgItem(IDC_Stripe_EDIT_R);
	m_ctlStripeEditR->SetLimitText(3);
	SetDlgItemText(IDC_Stripe_EDIT_G, __T("0"));
	CEdit *m_ctlStripeEditG = (CEdit*) GetDlgItem(IDC_Stripe_EDIT_G);
	m_ctlStripeEditG->SetLimitText(3);
	SetDlgItemText(IDC_Stripe_EDIT_B, __T("0"));
	CEdit *m_ctlStripeEditB = (CEdit*) GetDlgItem(IDC_Stripe_EDIT_B);
	m_ctlStripeEditB->SetLimitText(3);
	CheckRadioButton(IDC_Stripe_RADIO0_High, IDC_Stripe_RADIO0_Low, IDC_Stripe_RADIO0_Low);
	CheckRadioButton(IDC_Stripe_RADIO1_B100, IDC_Stripe_RADIO1_B20, IDC_Stripe_RADIO1_B100);

	CSliderCtrl *m_ctlG12SliderR = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_R);
	m_ctlG12SliderR->SetRange(0, 255);
	m_ctlG12SliderR->SetPos(255);
	CSliderCtrl *m_ctlG12SliderG = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_G);
	m_ctlG12SliderG->SetRange(0, 255);
	CSliderCtrl *m_ctlG12SliderB = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_B);
	m_ctlG12SliderB->SetRange(0, 255);


	CSliderCtrl *m_ctlG34SliderR = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_R);
	m_ctlG34SliderR->SetRange(0, 255);
	m_ctlG34SliderR->SetPos(255);
	CSliderCtrl *m_ctlG34SliderG = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_G);
	m_ctlG34SliderG->SetRange(0, 255);
	CSliderCtrl *m_ctlG34SliderB = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_B);
	m_ctlG34SliderB->SetRange(0, 255);

	CSliderCtrl *m_ctlG5SliderR = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_R);
	m_ctlG5SliderR->SetRange(0, 255);
	m_ctlG5SliderR->SetPos(255);
	CSliderCtrl *m_ctlG5SliderG = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_G);
	m_ctlG5SliderG->SetRange(0, 255);
	CSliderCtrl *m_ctlG5SliderB = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_B);
	m_ctlG5SliderB->SetRange(0, 255);

	CSliderCtrl *m_ctlRGB1SliderR = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_R);
	m_ctlRGB1SliderR->SetRange(0, 255);
	m_ctlRGB1SliderR->SetPos(255);
	CSliderCtrl *m_ctlRGB1SliderG = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_G);
	m_ctlRGB1SliderG->SetRange(0, 255);
	CSliderCtrl *m_ctlRGB1SliderB = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_B);
	m_ctlRGB1SliderB->SetRange(0, 255);

	CSliderCtrl *m_ctlBarSliderR = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_R);
	m_ctlBarSliderR->SetRange(0, 255);
	m_ctlBarSliderR->SetPos(255);
	CSliderCtrl *m_ctlBarSliderG = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_G);
	m_ctlBarSliderG->SetRange(0, 255);
	CSliderCtrl *m_ctlBarSliderB = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_B);
	m_ctlBarSliderB->SetRange(0, 255);

	CSliderCtrl *m_ctlGraphicSliderR = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_R);
	m_ctlGraphicSliderR->SetRange(0, 255);
	m_ctlGraphicSliderR->SetPos(255);
	CSliderCtrl *m_ctlGraphicSliderG = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_G);
	m_ctlGraphicSliderG->SetRange(0, 255);
	CSliderCtrl *m_ctlGraphicSliderB = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_B);
	m_ctlGraphicSliderB->SetRange(0, 255);

	CSliderCtrl *m_ctlStripeSliderR = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_R);
	m_ctlStripeSliderR->SetRange(0, 255);
	m_ctlStripeSliderR->SetPos(255);
	CSliderCtrl *m_ctlStripeSliderG = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_G);
	m_ctlStripeSliderG->SetRange(0, 255);
	CSliderCtrl *m_ctlStripeSliderB = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_B);
	m_ctlStripeSliderB->SetRange(0, 255);

	::CoInitialize(NULL);
	CoCreateInstance(CLSID_MMDeviceEnumerator, NULL, CLSCTX_INPROC_SERVER, IID_IMMDeviceEnumerator, (void**)&m_pIMMEnumerator);
	m_pIMMEnumerator->GetDefaultAudioEndpoint(eRender, eConsole, &pIMMDeivce);
	pIMMDeivce->Activate(IID_IAudioEndpointVolume, CLSCTX_ALL, NULL, (void**)&m_pEPVolume);
	pIMMDeivce->Activate(IID_IAudioMeterInformation, CLSCTX_ALL, NULL, (void**)&m_pRenderEndptVol);

	StartTimer(TimerNumber, HIDTransferTime);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CDialogLed::OnOK() 
{
	// TODO: Add extra validation here
	CDialog::OnOK();
}

void CDialogLed::OnCancel() 
{
	// TODO: Add extra cleanup here
	CDialog::OnCancel();
}


void CDialogLed::OnBnClickedButtonApply()
{
	unsigned char SendBuffer[HID_MAX_PACKET_SIZE_EP] = {0};
    BOOL bRet;

	// TODO: 在此加入控制項告知處理常式程式碼
	if(isDeviceOpened == TRUE)
	{
		/* Header */
		SendBuffer[0] = 2;

		/* Lighting Mode */
		CString cs_G12LightingMode;
		GetDlgItemTextW(IDC_COMBO_G12_LightingMode, cs_G12LightingMode);
		if(cs_G12LightingMode == "Disable")
			SendBuffer[1] = 0;
		else if(cs_G12LightingMode == "No Animation")
			SendBuffer[1] = 1;
		else if(cs_G12LightingMode == "Breathing")
			SendBuffer[1] = 2;
		else if(cs_G12LightingMode == "Flashing")
			SendBuffer[1] = 3;
		else if(cs_G12LightingMode == "Double Flashing")
			SendBuffer[1] = 4;
		else if(cs_G12LightingMode == "Marquees")
			SendBuffer[1] = 5;
		else if(cs_G12LightingMode == "Meteor")
			SendBuffer[1] = 6;
		else if(cs_G12LightingMode == "Rainbow")
			SendBuffer[1] = 7;
		else if(cs_G12LightingMode == "Lighting")
			SendBuffer[1] = 8;
		else if(cs_G12LightingMode == "Chasing Meteor")
			SendBuffer[1] = 9;
		else if(cs_G12LightingMode == "Up Down")
			SendBuffer[1] = 10;
		else if(cs_G12LightingMode == "Waterfall")
			SendBuffer[1] = 11;
		else if(cs_G12LightingMode == "Stack")
			SendBuffer[1] = 12;
		else if(cs_G12LightingMode == "Rainbow Waterfall")
			SendBuffer[1] = 13;

		/* Color R */
		SendBuffer[2] = GetDlgItemInt(IDC_G12_EDIT_R, NULL, 0);

		/* Color G */
		SendBuffer[3] = GetDlgItemInt(IDC_G12_EDIT_G, NULL, 0);

		/* Color B */
		SendBuffer[4] = GetDlgItemInt(IDC_G12_EDIT_B, NULL, 0);

		/* Breathing Speed */
		switch(GetCheckedRadioButton(IDC_G12_RADIO0_High, IDC_G12_RADIO0_Low))
		{
			case IDC_G12_RADIO0_High:
				SendBuffer[5] = 2;
				break;
			case IDC_G12_RADIO0_Medium:
				SendBuffer[5] = 1;
				break;
			case IDC_G12_RADIO0_Low:
				SendBuffer[5] = 0;
				break;
		}
	
		/* Brightness */
		switch(GetCheckedRadioButton(IDC_G12_RADIO1_B100, IDC_G12_RADIO1_B20))
		{
			case IDC_G12_RADIO1_B100:
				SendBuffer[6] = 10;
				break;
			case IDC_G12_RADIO1_B80:
				SendBuffer[6] = 8;
				break;
			case IDC_G12_RADIO1_B60:
				SendBuffer[6] = 6;
				break;
			case IDC_G12_RADIO1_B40:
				SendBuffer[6] = 4;
				break;
			case IDC_G12_RADIO1_B20:
				SendBuffer[6] = 2;
				break;
		}

		/* Lighting Mode */
		CString cs_G34LightingMode;
		GetDlgItemTextW(IDC_COMBO_G34_LightingMode, cs_G34LightingMode);
		if(cs_G34LightingMode == "Disable")
			SendBuffer[7] = 0;
		else if(cs_G34LightingMode == "No Animation")
			SendBuffer[7] = 1;
		else if(cs_G34LightingMode == "Breathing")
			SendBuffer[7] = 2;
		else if(cs_G34LightingMode == "Flashing")
			SendBuffer[7] = 3;
		else if(cs_G34LightingMode == "Double Flashing")
			SendBuffer[7] = 4;
		else if(cs_G34LightingMode == "Marquees")
			SendBuffer[7] = 5;
		else if(cs_G34LightingMode == "Meteor")
			SendBuffer[7] = 6;
		else if(cs_G34LightingMode == "Rainbow")
			SendBuffer[7] = 7;
		else if(cs_G34LightingMode == "Lighting")
			SendBuffer[7] = 8;
		else if(cs_G34LightingMode == "Chasing Meteor")
			SendBuffer[7] = 9;
		else if(cs_G34LightingMode == "Up Down")
			SendBuffer[7] = 10;
		else if(cs_G34LightingMode == "Waterfall")
			SendBuffer[7] = 11;
		else if(cs_G34LightingMode == "Stack")
			SendBuffer[7] = 12;
		else if(cs_G34LightingMode == "Rainbow Waterfall")
			SendBuffer[7] = 13;

		/* Color R */
		SendBuffer[8] = GetDlgItemInt(IDC_G34_EDIT_R, NULL, 0);

		/* Color G */
		SendBuffer[9] = GetDlgItemInt(IDC_G34_EDIT_G, NULL, 0);

		/* Color B */
		SendBuffer[10] = GetDlgItemInt(IDC_G34_EDIT_B, NULL, 0);

		/* Breathing Speed */
		switch(GetCheckedRadioButton(IDC_G34_RADIO0_High, IDC_G34_RADIO0_Low))
		{
			case IDC_G34_RADIO0_High:
				SendBuffer[11] = 2;
				break;
			case IDC_G34_RADIO0_Medium:
				SendBuffer[11] = 1;
				break;
			case IDC_G34_RADIO0_Low:
				SendBuffer[11] = 0;
				break;
		}
	
		/* Brightness */
		switch(GetCheckedRadioButton(IDC_G34_RADIO1_B100, IDC_G34_RADIO1_B20))
		{
			case IDC_G34_RADIO1_B100:
				SendBuffer[12] = 10;
				break;
			case IDC_G34_RADIO1_B80:
				SendBuffer[12] = 8;
				break;
			case IDC_G34_RADIO1_B60:
				SendBuffer[12] = 6;
				break;
			case IDC_G34_RADIO1_B40:
				SendBuffer[12] = 4;
				break;
			case IDC_G34_RADIO1_B20:
				SendBuffer[12] = 2;
				break;
		}

		/* Lighting Mode */
		CString cs_G5LightingMode;
		GetDlgItemTextW(IDC_COMBO_G5_LightingMode, cs_G5LightingMode);
		if(cs_G5LightingMode == "Disable")
			SendBuffer[13] = 0;
		else if(cs_G5LightingMode == "No Animation")
			SendBuffer[13] = 1;
		else if(cs_G5LightingMode == "Breathing")
			SendBuffer[13] = 2;
		else if(cs_G5LightingMode == "Flashing")
			SendBuffer[13] = 3;
		else if(cs_G5LightingMode == "Double Flashing")
			SendBuffer[13] = 4;
		else if(cs_G5LightingMode == "Marquees")
			SendBuffer[13] = 5;
		else if(cs_G5LightingMode == "Meteor")
			SendBuffer[13] = 6;
		else if(cs_G5LightingMode == "Rainbow")
			SendBuffer[13] = 7;
		else if(cs_G5LightingMode == "Lighting")
			SendBuffer[13] = 8;
		else if(cs_G5LightingMode == "Chasing Meteor")
			SendBuffer[13] = 9;
		else if(cs_G5LightingMode == "Up Down")
			SendBuffer[13] = 10;
		else if(cs_G5LightingMode == "Waterfall")
			SendBuffer[13] = 11;
		else if(cs_G5LightingMode == "Stack")
			SendBuffer[13] = 12;
		else if(cs_G5LightingMode == "Rainbow Waterfall")
			SendBuffer[13] = 13;

		/* Color R */
		SendBuffer[14] = GetDlgItemInt(IDC_G5_EDIT_R, NULL, 0);

		/* Color G */
		SendBuffer[15] = GetDlgItemInt(IDC_G5_EDIT_G, NULL, 0);

		/* Color B */
		SendBuffer[16] = GetDlgItemInt(IDC_G5_EDIT_B, NULL, 0);

		/* Breathing Speed */
		switch(GetCheckedRadioButton(IDC_G5_RADIO0_High, IDC_G5_RADIO0_Low))
		{
			case IDC_G5_RADIO0_High:
				SendBuffer[17] = 2;
				break;
			case IDC_G5_RADIO0_Medium:
				SendBuffer[17] = 1;
				break;
			case IDC_G5_RADIO0_Low:
				SendBuffer[17] = 0;
				break;
		}
	
		/* Brightness */
		switch(GetCheckedRadioButton(IDC_G5_RADIO1_B100, IDC_G5_RADIO1_B20))
		{
			case IDC_G5_RADIO1_B100:
				SendBuffer[18] = 10;
				break;
			case IDC_G5_RADIO1_B80:
				SendBuffer[18] = 8;
				break;
			case IDC_G5_RADIO1_B60:
				SendBuffer[18] = 6;
				break;
			case IDC_G5_RADIO1_B40:
				SendBuffer[18] = 4;
				break;
			case IDC_G5_RADIO1_B20:
				SendBuffer[18] = 2;
				break;
		}

		/* Lighting Mode */
		CString cs_RGB1LightingMode;
		GetDlgItemTextW(IDC_COMBO_RGB1_LightingMode, cs_RGB1LightingMode);
		if(cs_RGB1LightingMode == "Disable")
			SendBuffer[19] = 0;
		else if(cs_RGB1LightingMode == "No Animation")
			SendBuffer[19] = 1;
		else if(cs_RGB1LightingMode == "Breathing")
			SendBuffer[19] = 2;
		else if(cs_RGB1LightingMode == "Flashing")
			SendBuffer[19] = 3;
		else if(cs_RGB1LightingMode == "Double Flashing")
			SendBuffer[19] = 4;
		else if(cs_RGB1LightingMode == "Marquees")
			SendBuffer[19] = 5;
		else if(cs_RGB1LightingMode == "Meteor")
			SendBuffer[19] = 6;
		else if(cs_RGB1LightingMode == "Rainbow")
			SendBuffer[19] = 7;
		else if(cs_RGB1LightingMode == "Lighting")
			SendBuffer[19] = 8;
		else if(cs_RGB1LightingMode == "Chasing Meteor")
			SendBuffer[19] = 9;
		else if(cs_RGB1LightingMode == "Up Down")
			SendBuffer[19] = 10;
		else if(cs_RGB1LightingMode == "Waterfall")
			SendBuffer[19] = 11;
		else if(cs_RGB1LightingMode == "Stack")
			SendBuffer[19] = 12;
		else if(cs_RGB1LightingMode == "Rainbow Waterfall")
			SendBuffer[19] = 13;

		/* Color R */
		SendBuffer[20] = GetDlgItemInt(IDC_RGB1_EDIT_R, NULL, 0);

		/* Color G */
		SendBuffer[21] = GetDlgItemInt(IDC_RGB1_EDIT_G, NULL, 0);

		/* Color B */
		SendBuffer[22] = GetDlgItemInt(IDC_RGB1_EDIT_B, NULL, 0);

		/* Breathing Speed */
		switch(GetCheckedRadioButton(IDC_RGB1_RADIO0_High, IDC_RGB1_RADIO0_Low))
		{
			case IDC_RGB1_RADIO0_High:
				SendBuffer[23] = 2;
				break;
			case IDC_RGB1_RADIO0_Medium:
				SendBuffer[23] = 1;
				break;
			case IDC_RGB1_RADIO0_Low:
				SendBuffer[23] = 0;
				break;
		}
	
		/* Brightness */
		switch(GetCheckedRadioButton(IDC_RGB1_RADIO1_B100, IDC_RGB1_RADIO1_B20))
		{
			case IDC_RGB1_RADIO1_B100:
				SendBuffer[24] = 10;
				break;
			case IDC_RGB1_RADIO1_B80:
				SendBuffer[24] = 8;
				break;
			case IDC_RGB1_RADIO1_B60:
				SendBuffer[24] = 6;
				break;
			case IDC_RGB1_RADIO1_B40:
				SendBuffer[24] = 4;
				break;
			case IDC_RGB1_RADIO1_B20:
				SendBuffer[24] = 2;
				break;
		}

		/* Lighting Mode */
		CString cs_BarLightingMode;
		GetDlgItemTextW(IDC_COMBO_Bar_LightingMode, cs_BarLightingMode);
		if(cs_BarLightingMode == "Disable")
			SendBuffer[31] = 0;
		else if(cs_BarLightingMode == "No Animation")
			SendBuffer[31] = 1;
		else if(cs_BarLightingMode == "Breathing")
			SendBuffer[31] = 2;
		else if(cs_BarLightingMode == "Flashing")
			SendBuffer[31] = 3;
		else if(cs_BarLightingMode == "Double Flashing")
			SendBuffer[31] = 4;
		else if(cs_BarLightingMode == "Marquees")
			SendBuffer[31] = 5;
		else if(cs_BarLightingMode == "Meteor")
			SendBuffer[31] = 6;
		else if(cs_BarLightingMode == "Rainbow")
			SendBuffer[31] = 7;
		else if(cs_BarLightingMode == "Lighting")
			SendBuffer[31] = 8;
		else if(cs_BarLightingMode == "POP")
			SendBuffer[31] = 9;
		else if(cs_BarLightingMode == "JAZZ")
			SendBuffer[31] = 10;
		else if(cs_BarLightingMode == "Play")
			SendBuffer[31] = 11;
		else if(cs_BarLightingMode == "Movie")
			SendBuffer[31] = 12;

		/* Color R */
		SendBuffer[32] = GetDlgItemInt(IDC_Bar_EDIT_R, NULL, 0);

		/* Color G */
		SendBuffer[33] = GetDlgItemInt(IDC_Bar_EDIT_G, NULL, 0);

		/* Color B */
		SendBuffer[34] = GetDlgItemInt(IDC_Bar_EDIT_B, NULL, 0);

		/* Breathing Speed */
		switch(GetCheckedRadioButton(IDC_Bar_RADIO0_High, IDC_Bar_RADIO0_Low))
		{
			case IDC_Bar_RADIO0_High:
				SendBuffer[35] = 2;
				break;
			case IDC_Bar_RADIO0_Medium:
				SendBuffer[35] = 1;
				break;
			case IDC_Bar_RADIO0_Low:
				SendBuffer[35] = 0;
				break;
		}
	
		/* Brightness */
		switch(GetCheckedRadioButton(IDC_Bar_RADIO1_B100, IDC_Bar_RADIO1_B20))
		{
			case IDC_Bar_RADIO1_B100:
				SendBuffer[36] = 10;
				break;
			case IDC_Bar_RADIO1_B80:
				SendBuffer[36] = 8;
				break;
			case IDC_Bar_RADIO1_B60:
				SendBuffer[36] = 6;
				break;
			case IDC_Bar_RADIO1_B40:
				SendBuffer[36] = 4;
				break;
			case IDC_Bar_RADIO1_B20:
				SendBuffer[36] = 2;
				break;
		}

		/* Lighting Mode */
		CString cs_GraphicLightingMode;
		GetDlgItemTextW(IDC_COMBO_Graphic_LightingMode, cs_GraphicLightingMode);
		if(cs_GraphicLightingMode == "Disable")
			SendBuffer[25] = 0;
		else if(cs_GraphicLightingMode == "No Animation")
			SendBuffer[25] = 1;
		else if(cs_GraphicLightingMode == "Breathing")
			SendBuffer[25] = 2;
		else if(cs_GraphicLightingMode == "Flashing")
			SendBuffer[25] = 3;
		else if(cs_GraphicLightingMode == "Double Flashing")
			SendBuffer[25] = 4;
		else if(cs_GraphicLightingMode == "Marquees")
			SendBuffer[25] = 5;
		else if(cs_GraphicLightingMode == "Meteor")
			SendBuffer[25] = 6;
		else if(cs_GraphicLightingMode == "Rainbow")
			SendBuffer[25] = 7;
		else if(cs_GraphicLightingMode == "Lighting")
			SendBuffer[25] = 8;
		else if(cs_GraphicLightingMode == "POP")
			SendBuffer[25] = 9;
		else if(cs_GraphicLightingMode == "JAZZ")
			SendBuffer[25] = 10;
		else if(cs_GraphicLightingMode == "Play")
			SendBuffer[25] = 11;
		else if(cs_GraphicLightingMode == "Movie")
			SendBuffer[25] = 12;

		/* Color R */
		SendBuffer[26] = GetDlgItemInt(IDC_Graphic_EDIT_R, NULL, 0);

		/* Color G */
		SendBuffer[27] = GetDlgItemInt(IDC_Graphic_EDIT_G, NULL, 0);

		/* Color B */
		SendBuffer[28] = GetDlgItemInt(IDC_Graphic_EDIT_B, NULL, 0);

		/* Breathing Speed */
		switch(GetCheckedRadioButton(IDC_Graphic_RADIO0_High, IDC_Graphic_RADIO0_Low))
		{
			case IDC_Graphic_RADIO0_High:
				SendBuffer[29] = 2;
				break;
			case IDC_Graphic_RADIO0_Medium:
				SendBuffer[29] = 1;
				break;
			case IDC_Graphic_RADIO0_Low:
				SendBuffer[29] = 0;
				break;
		}
	
		/* Brightness */
		switch(GetCheckedRadioButton(IDC_Graphic_RADIO1_B100, IDC_Graphic_RADIO1_B20))
		{
			case IDC_Graphic_RADIO1_B100:
				SendBuffer[30] = 10;
				break;
			case IDC_Graphic_RADIO1_B80:
				SendBuffer[30] = 8;
				break;
			case IDC_Graphic_RADIO1_B60:
				SendBuffer[30] = 6;
				break;
			case IDC_Graphic_RADIO1_B40:
				SendBuffer[30] = 4;
				break;
			case IDC_Graphic_RADIO1_B20:
				SendBuffer[30] = 2;
				break;
		}

		/* Lighting Mode */
		CString cs_StripeLightingMode;
		GetDlgItemTextW(IDC_COMBO_Stripe_LightingMode, cs_StripeLightingMode);
		if(cs_StripeLightingMode == "Disable")
			SendBuffer[37] = 0;
		else if(cs_StripeLightingMode == "No Animation")
			SendBuffer[37] = 1;
		else if(cs_StripeLightingMode == "Breathing")
			SendBuffer[37] = 2;
		else if(cs_StripeLightingMode == "Flashing")
			SendBuffer[37] = 3;
		else if(cs_StripeLightingMode == "Double Flashing")
			SendBuffer[37] = 4;
		else if(cs_StripeLightingMode == "Marquees")
			SendBuffer[37] = 5;
		else if(cs_StripeLightingMode == "Meteor")
			SendBuffer[37] = 6;
		else if(cs_StripeLightingMode == "Rainbow")
			SendBuffer[37] = 7;
		else if(cs_StripeLightingMode == "Lighting")
			SendBuffer[37] = 8;
		else if(cs_StripeLightingMode == "POP")
			SendBuffer[37] = 9;
		else if(cs_StripeLightingMode == "JAZZ")
			SendBuffer[37] = 10;
		else if(cs_StripeLightingMode == "Play")
			SendBuffer[37] = 11;
		else if(cs_StripeLightingMode == "Movie")
			SendBuffer[37] = 12;

		/* Color R */
		SendBuffer[38] = GetDlgItemInt(IDC_Stripe_EDIT_R, NULL, 0);

		/* Color G */
		SendBuffer[39] = GetDlgItemInt(IDC_Stripe_EDIT_G, NULL, 0);

		/* Color B */
		SendBuffer[40] = GetDlgItemInt(IDC_Stripe_EDIT_B, NULL, 0);

		/* Breathing Speed */
		switch(GetCheckedRadioButton(IDC_Stripe_RADIO0_High, IDC_Stripe_RADIO0_Low))
		{
			case IDC_Stripe_RADIO0_High:
				SendBuffer[41] = 2;
				break;
			case IDC_Stripe_RADIO0_Medium:
				SendBuffer[41] = 1;
				break;
			case IDC_Stripe_RADIO0_Low:
				SendBuffer[41] = 0;
				break;
		}
	
		/* Brightness */
		switch(GetCheckedRadioButton(IDC_Stripe_RADIO1_B100, IDC_Stripe_RADIO1_B20))
		{
			case IDC_Stripe_RADIO1_B100:
				SendBuffer[42] = 10;
				break;
			case IDC_Stripe_RADIO1_B80:
				SendBuffer[42] = 8;
				break;
			case IDC_Stripe_RADIO1_B60:
				SendBuffer[42] = 6;
				break;
			case IDC_Stripe_RADIO1_B40:
				SendBuffer[42] = 4;
				break;
			case IDC_Stripe_RADIO1_B20:
				SendBuffer[42] = 2;
				break;
		}

		/* Store Flash */
		CButton *m_ctlCheck = (CButton*) GetDlgItem(IDC_CHECK_Store);
		if(m_ctlCheck->GetCheck())
			SendBuffer[43] = 1;
		else
			SendBuffer[43] = 0;

		/* Set Feature to LED DEMO Device */
		bRet = io.SetFeature((unsigned char *)&SendBuffer, sizeof(SendBuffer));
        if(!bRet)
        {
            AfxMessageBox(_T("ERROR: Send Command Error!"));
        }
	}
	else
		AfxMessageBox(_T("LED DEMO Device isn't Connected."));
}


void CDialogLed::OnNMCustomdrawG12SliderR(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_R);
	SetDlgItemInt(IDC_G12_EDIT_R, m_ctlSliderR->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawG12SliderG(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_G);
	SetDlgItemInt(IDC_G12_EDIT_G, m_ctlSliderG->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawG12SliderB(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_B);
	SetDlgItemInt(IDC_G12_EDIT_B, m_ctlSliderB->GetPos(), 0);

	*pResult = 0;
}

void CDialogLed::OnNMCustomdrawG34SliderR(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_R);
	SetDlgItemInt(IDC_G34_EDIT_R, m_ctlSliderR->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawG34SliderG(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_G);
	SetDlgItemInt(IDC_G34_EDIT_G, m_ctlSliderG->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawG34SliderB(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_B);
	SetDlgItemInt(IDC_G34_EDIT_B, m_ctlSliderB->GetPos(), 0);

	*pResult = 0;
}

void CDialogLed::OnNMCustomdrawG5SliderR(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_R);
	SetDlgItemInt(IDC_G5_EDIT_R, m_ctlSliderR->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawG5SliderG(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_G);
	SetDlgItemInt(IDC_G5_EDIT_G, m_ctlSliderG->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawG5SliderB(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_B);
	SetDlgItemInt(IDC_G5_EDIT_B, m_ctlSliderB->GetPos(), 0);

	*pResult = 0;
}

void CDialogLed::OnNMCustomdrawRGB1SliderR(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_R);
	SetDlgItemInt(IDC_RGB1_EDIT_R, m_ctlSliderR->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawRGB1SliderG(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_G);
	SetDlgItemInt(IDC_RGB1_EDIT_G, m_ctlSliderG->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawRGB1SliderB(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_B);
	SetDlgItemInt(IDC_RGB1_EDIT_B, m_ctlSliderB->GetPos(), 0);

	*pResult = 0;
}

void CDialogLed::OnNMCustomdrawBarSliderR(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_R);
	SetDlgItemInt(IDC_Bar_EDIT_R, m_ctlSliderR->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawBarSliderG(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_G);
	SetDlgItemInt(IDC_Bar_EDIT_G, m_ctlSliderG->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawBarSliderB(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_B);
	SetDlgItemInt(IDC_Bar_EDIT_B, m_ctlSliderB->GetPos(), 0);

	*pResult = 0;
}

void CDialogLed::OnNMCustomdrawGraphicSliderR(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_R);
	SetDlgItemInt(IDC_Graphic_EDIT_R, m_ctlSliderR->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawGraphicSliderG(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_G);
	SetDlgItemInt(IDC_Graphic_EDIT_G, m_ctlSliderG->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawGraphicSliderB(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_B);
	SetDlgItemInt(IDC_Graphic_EDIT_B, m_ctlSliderB->GetPos(), 0);

	*pResult = 0;
}

void CDialogLed::OnNMCustomdrawStripeSliderR(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_R);
	SetDlgItemInt(IDC_Stripe_EDIT_R, m_ctlSliderR->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawStripeSliderG(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_G);
	SetDlgItemInt(IDC_Stripe_EDIT_G, m_ctlSliderG->GetPos(), 0);

	*pResult = 0;
}


void CDialogLed::OnNMCustomdrawStripeSliderB(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: 在此加入控制項告知處理常式程式碼
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_B);
	SetDlgItemInt(IDC_Stripe_EDIT_B, m_ctlSliderB->GetPos(), 0);

	*pResult = 0;
}

void CDialogLed::OnEnChangeG12EditR()
{
	unsigned int Color_R;
	CEdit *m_ctlEditR = (CEdit*) GetDlgItem(IDC_G12_EDIT_R);
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_R);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_R = GetDlgItemInt(IDC_G12_EDIT_R, NULL, 0);
	if(Color_R > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G12_EDIT_R, __T("0"));
		m_ctlSliderR->SetPos(0);
	}
	else
		m_ctlSliderR->SetPos(Color_R);

	m_ctlEditR->SetSel(3, 3);
}


void CDialogLed::OnEnChangeG12EditG()
{
	unsigned int Color_G;
	CEdit *m_ctlEditG = (CEdit*) GetDlgItem(IDC_G12_EDIT_G);
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_G);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_G = GetDlgItemInt(IDC_G12_EDIT_G, NULL, 0);
	if(Color_G > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G12_EDIT_G, __T("0"));
		m_ctlSliderG->SetPos(0);
	}
	else
		m_ctlSliderG->SetPos(Color_G);

	m_ctlEditG->SetSel(3, 3);
}


void CDialogLed::OnEnChangeG12EditB()
{
	unsigned int Color_B;
	CEdit *m_ctlEditB = (CEdit*) GetDlgItem(IDC_G12_EDIT_B);
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_G12_SLIDER_B);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_B = GetDlgItemInt(IDC_G12_EDIT_B, NULL, 0);
	if(Color_B > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G12_EDIT_B, __T("0"));
		m_ctlSliderB->SetPos(0);
	}
	else
		m_ctlSliderB->SetPos(Color_B);

	m_ctlEditB->SetSel(3, 3);
}

void CDialogLed::OnEnChangeG34EditR()
{
	unsigned int Color_R;
	CEdit *m_ctlEditR = (CEdit*) GetDlgItem(IDC_G34_EDIT_R);
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_R);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_R = GetDlgItemInt(IDC_G34_EDIT_R, NULL, 0);
	if(Color_R > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G34_EDIT_R, __T("0"));
		m_ctlSliderR->SetPos(0);
	}
	else
		m_ctlSliderR->SetPos(Color_R);

	m_ctlEditR->SetSel(3, 3);
}


void CDialogLed::OnEnChangeG34EditG()
{
	unsigned int Color_G;
	CEdit *m_ctlEditG = (CEdit*) GetDlgItem(IDC_G34_EDIT_G);
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_G);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_G = GetDlgItemInt(IDC_G34_EDIT_G, NULL, 0);
	if(Color_G > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G34_EDIT_G, __T("0"));
		m_ctlSliderG->SetPos(0);
	}
	else
		m_ctlSliderG->SetPos(Color_G);

	m_ctlEditG->SetSel(3, 3);
}

void CDialogLed::OnEnChangeG34EditB()
{
	unsigned int Color_B;
	CEdit *m_ctlEditB = (CEdit*) GetDlgItem(IDC_G34_EDIT_B);
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_G34_SLIDER_B);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_B = GetDlgItemInt(IDC_G34_EDIT_B, NULL, 0);
	if(Color_B > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G34_EDIT_B, __T("0"));
		m_ctlSliderB->SetPos(0);
	}
	else
		m_ctlSliderB->SetPos(Color_B);

	m_ctlEditB->SetSel(3, 3);
}

void CDialogLed::OnEnChangeG5EditR()
{
	unsigned int Color_R;
	CEdit *m_ctlEditR = (CEdit*) GetDlgItem(IDC_G5_EDIT_R);
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_R);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_R = GetDlgItemInt(IDC_G5_EDIT_R, NULL, 0);
	if(Color_R > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G5_EDIT_R, __T("0"));
		m_ctlSliderR->SetPos(0);
	}
	else
		m_ctlSliderR->SetPos(Color_R);

	m_ctlEditR->SetSel(3, 3);
}

void CDialogLed::OnEnChangeG5EditG()
{
	unsigned int Color_G;
	CEdit *m_ctlEditG = (CEdit*) GetDlgItem(IDC_G5_EDIT_G);
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_G);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_G = GetDlgItemInt(IDC_G5_EDIT_G, NULL, 0);
	if(Color_G > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G5_EDIT_G, __T("0"));
		m_ctlSliderG->SetPos(0);
	}
	else
		m_ctlSliderG->SetPos(Color_G);

	m_ctlEditG->SetSel(3, 3);
}


void CDialogLed::OnEnChangeG5EditB()
{
	unsigned int Color_B;
	CEdit *m_ctlEditB = (CEdit*) GetDlgItem(IDC_G5_EDIT_B);
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_G5_SLIDER_B);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_B = GetDlgItemInt(IDC_G5_EDIT_B, NULL, 0);
	if(Color_B > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_G5_EDIT_B, __T("0"));
		m_ctlSliderB->SetPos(0);
	}
	else
		m_ctlSliderB->SetPos(Color_B);

	m_ctlEditB->SetSel(3, 3);
}

void CDialogLed::OnEnChangeRGB1EditR()
{
	unsigned int Color_R;
	CEdit *m_ctlEditR = (CEdit*) GetDlgItem(IDC_RGB1_EDIT_R);
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_R);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_R = GetDlgItemInt(IDC_RGB1_EDIT_R, NULL, 0);
	if(Color_R > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_RGB1_EDIT_R, __T("0"));
		m_ctlSliderR->SetPos(0);
	}
	else
		m_ctlSliderR->SetPos(Color_R);

	m_ctlEditR->SetSel(3, 3);
}

void CDialogLed::OnEnChangeRGB1EditG()
{
	unsigned int Color_G;
	CEdit *m_ctlEditG = (CEdit*) GetDlgItem(IDC_RGB1_EDIT_G);
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_G);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_G = GetDlgItemInt(IDC_RGB1_EDIT_G, NULL, 0);
	if(Color_G > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_RGB1_EDIT_G, __T("0"));
		m_ctlSliderG->SetPos(0);
	}
	else
		m_ctlSliderG->SetPos(Color_G);

	m_ctlEditG->SetSel(3, 3);
}


void CDialogLed::OnEnChangeRGB1EditB()
{
	unsigned int Color_B;
	CEdit *m_ctlEditB = (CEdit*) GetDlgItem(IDC_RGB1_EDIT_B);
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_RGB1_SLIDER_B);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_B = GetDlgItemInt(IDC_RGB1_EDIT_B, NULL, 0);
	if(Color_B > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_RGB1_EDIT_B, __T("0"));
		m_ctlSliderB->SetPos(0);
	}
	else
		m_ctlSliderB->SetPos(Color_B);

	m_ctlEditB->SetSel(3, 3);
}

void CDialogLed::OnEnChangeBarEditR()
{
	unsigned int Color_R;
	CEdit *m_ctlEditR = (CEdit*) GetDlgItem(IDC_Bar_EDIT_R);
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_R);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_R = GetDlgItemInt(IDC_Bar_EDIT_R, NULL, 0);
	if(Color_R > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Bar_EDIT_R, __T("0"));
		m_ctlSliderR->SetPos(0);
	}
	else
		m_ctlSliderR->SetPos(Color_R);

	m_ctlEditR->SetSel(3, 3);
}

void CDialogLed::OnEnChangeBarEditG()
{
	unsigned int Color_G;
	CEdit *m_ctlEditG = (CEdit*) GetDlgItem(IDC_Bar_EDIT_G);
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_G);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_G = GetDlgItemInt(IDC_Bar_EDIT_G, NULL, 0);
	if(Color_G > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Bar_EDIT_G, __T("0"));
		m_ctlSliderG->SetPos(0);
	}
	else
		m_ctlSliderG->SetPos(Color_G);

	m_ctlEditG->SetSel(3, 3);
}


void CDialogLed::OnEnChangeBarEditB()
{
	unsigned int Color_B;
	CEdit *m_ctlEditB = (CEdit*) GetDlgItem(IDC_Bar_EDIT_B);
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_Bar_SLIDER_B);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_B = GetDlgItemInt(IDC_Bar_EDIT_B, NULL, 0);
	if(Color_B > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Bar_EDIT_B, __T("0"));
		m_ctlSliderB->SetPos(0);
	}
	else
		m_ctlSliderB->SetPos(Color_B);

	m_ctlEditB->SetSel(3, 3);
}

void CDialogLed::OnEnChangeGraphicEditR()
{
	unsigned int Color_R;
	CEdit *m_ctlEditR = (CEdit*) GetDlgItem(IDC_Graphic_EDIT_R);
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_R);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_R = GetDlgItemInt(IDC_Graphic_EDIT_R, NULL, 0);
	if(Color_R > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Graphic_EDIT_R, __T("0"));
		m_ctlSliderR->SetPos(0);
	}
	else
		m_ctlSliderR->SetPos(Color_R);

	m_ctlEditR->SetSel(3, 3);
}

void CDialogLed::OnEnChangeGraphicEditG()
{
	unsigned int Color_G;
	CEdit *m_ctlEditG = (CEdit*) GetDlgItem(IDC_Graphic_EDIT_G);
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_G);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_G = GetDlgItemInt(IDC_Graphic_EDIT_G, NULL, 0);
	if(Color_G > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Graphic_EDIT_G, __T("0"));
		m_ctlSliderG->SetPos(0);
	}
	else
		m_ctlSliderG->SetPos(Color_G);

	m_ctlEditG->SetSel(3, 3);
}


void CDialogLed::OnEnChangeGraphicEditB()
{
	unsigned int Color_B;
	CEdit *m_ctlEditB = (CEdit*) GetDlgItem(IDC_Graphic_EDIT_B);
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_Graphic_SLIDER_B);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_B = GetDlgItemInt(IDC_Graphic_EDIT_B, NULL, 0);
	if(Color_B > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Graphic_EDIT_B, __T("0"));
		m_ctlSliderB->SetPos(0);
	}
	else
		m_ctlSliderB->SetPos(Color_B);

	m_ctlEditB->SetSel(3, 3);
}

void CDialogLed::OnEnChangeStripeEditR()
{
	unsigned int Color_R;
	CEdit *m_ctlEditR = (CEdit*) GetDlgItem(IDC_Stripe_EDIT_R);
	CSliderCtrl *m_ctlSliderR = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_R);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_R = GetDlgItemInt(IDC_Stripe_EDIT_R, NULL, 0);
	if(Color_R > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Stripe_EDIT_R, __T("0"));
		m_ctlSliderR->SetPos(0);
	}
	else
		m_ctlSliderR->SetPos(Color_R);

	m_ctlEditR->SetSel(3, 3);
}

void CDialogLed::OnEnChangeStripeEditG()
{
	unsigned int Color_G;
	CEdit *m_ctlEditG = (CEdit*) GetDlgItem(IDC_Stripe_EDIT_G);
	CSliderCtrl *m_ctlSliderG = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_G);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_G = GetDlgItemInt(IDC_Stripe_EDIT_G, NULL, 0);
	if(Color_G > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Stripe_EDIT_G, __T("0"));
		m_ctlSliderG->SetPos(0);
	}
	else
		m_ctlSliderG->SetPos(Color_G);

	m_ctlEditG->SetSel(3, 3);
}


void CDialogLed::OnEnChangeStripeEditB()
{
	unsigned int Color_B;
	CEdit *m_ctlEditB = (CEdit*) GetDlgItem(IDC_Stripe_EDIT_B);
	CSliderCtrl *m_ctlSliderB = (CSliderCtrl*) GetDlgItem(IDC_Stripe_SLIDER_B);
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialog::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
	Color_B = GetDlgItemInt(IDC_Stripe_EDIT_B, NULL, 0);
	if(Color_B > 255)
	{
		AfxMessageBox(_T("Error Data Range. Out of 0 ~ 255"));
		SetDlgItemText(IDC_Stripe_EDIT_B, __T("0"));
		m_ctlSliderB->SetPos(0);
	}
	else
		m_ctlSliderB->SetPos(Color_B);

	m_ctlEditB->SetSel(3, 3);
}

void CDialogLed::OnBnClickedButtonConnect()
{
	// TODO: 在此加入控制項告知處理常式程式碼
    if(isDeviceOpened == FALSE)
	{    
		if(!io.OpenDevice(0x0416, 0x5020))
		{
			AfxMessageBox(_T("Can't Open LED DEMO Device"));
			io.CloseDevice();
		}
		else
		{
			isDeviceOpened = TRUE;
			AfxMessageBox(_T("LED DEMO Device Open Success."));

			SetDlgItemText(IDC_BUTTON_Connect, _T("Disconnect"));
		}
	}
	else
	{
		io.CloseDevice();
		SetDlgItemText(IDC_BUTTON_Connect, _T("Connect"));
		isDeviceOpened = FALSE;
	}
}


void CDialogLed::OnCbnSelchangeComboG12Lightingmode()
{
	// TODO: 在此加入控制項告知處理常式程式碼
}

void CDialogLed::OnCbnSelchangeComboG34Lightingmode()
{
	// TODO: 在此加入控制項告知處理常式程式碼
}

void CDialogLed::OnCbnSelchangeComboG5Lightingmode()
{
	// TODO: 在此加入控制項告知處理常式程式碼
}

void CDialogLed::OnCbnSelchangeComboRGB1Lightingmode()
{
	// TODO: 在此加入控制項告知處理常式程式碼
}

void CDialogLed::OnCbnSelchangeComboBarLightingmode()
{
	// TODO: 在此加入控制項告知處理常式程式碼
}

void CDialogLed::OnCbnSelchangeComboGraphicLightingmode()
{
	// TODO: 在此加入控制項告知處理常式程式碼
}

void CDialogLed::OnCbnSelchangeComboStripeLightingmode()
{
	// TODO: 在此加入控制項告知處理常式程式碼
}

void CDialogLed::StartTimer(UINT_PTR nIDEvent, UINT milisecond)
{
	SetTimer(nIDEvent, milisecond, NULL);
}


void CDialogLed::OnTimer(UINT_PTR nIDEvent)
{
    if (nIDEvent == TimerNumber) {
		CString lstr;
		CString rstr;
		BOOL isMute;

		UINT Count;
		float level = 0.0f;
		float Audio_level[2] = {0.0};
		int Main_volume;
		int Left_volume;
		int Right_volume;

		m_pEPVolume->GetMute(&isMute);
		m_pRenderEndptVol->GetPeakValue(&level);
		m_pRenderEndptVol->GetMeteringChannelCount(&Count);
		m_pRenderEndptVol->GetChannelsPeakValues(Count, Audio_level);
		isMute = !isMute;
		Main_volume = (int)(level * 100 * isMute);
		Left_volume = (int)(Audio_level[0] * 100 * isMute);
		Right_volume = (int)(Audio_level[1] * 100 * isMute);

		/* Transfer to MCU */
		CMD_T cmd;
		unsigned long length;
		BOOL bRet;
		TCHAR *pEnd;
		CString GET_PID;
		GetDlgItemTextW(IDC_EDIT_PID, GET_PID);
		USHORT MSI_PID = ::_tcstoul(GET_PID, &pEnd, 16);

		if ((isDeviceOpened == TRUE) && (MSI_PID != 0x3F00) ) {
			cmd.cmd = HID_CMD_AudioVolume;
			//cmd.u8AudioLeft = volume;
			//cmd.u8AudioRight = volume;
			cmd.u8AudioMain = Main_volume;
			cmd.u8AudioLeft = Left_volume;
			cmd.u8AudioRight = Right_volume;
			bRet = io.WriteFile((unsigned char *)&cmd, sizeof(cmd), &length, USB_TIME_OUT);

			if (!bRet) {
				//AfxMessageBox(_T("Command Transfer Failed.\nClose Connection."));
				io.CloseDevice();
				SetDlgItemText(IDC_BUTTON_Connect, _T("Connect"));
				isDeviceOpened = FALSE;
			}
		}
    }

    CDialog::OnTimer(nIDEvent);
}

void CDialogLed::StopTimer(UINT_PTR nIDEvent)
{
    KillTimer(nIDEvent);
}
